// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from pacmod_msgs:msg/AccelAuxRpt.idl
// generated code does not contain a copyright notice
#include "pacmod_msgs/msg/detail/accel_aux_rpt__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
pacmod_msgs__msg__AccelAuxRpt__init(pacmod_msgs__msg__AccelAuxRpt * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    pacmod_msgs__msg__AccelAuxRpt__fini(msg);
    return false;
  }
  // raw_pedal_pos
  // raw_pedal_pos_is_valid
  // raw_pedal_force
  // raw_pedal_force_is_valid
  // user_interaction
  // user_interaction_is_valid
  // brake_interlock_active
  // brake_interlock_active_is_valid
  return true;
}

void
pacmod_msgs__msg__AccelAuxRpt__fini(pacmod_msgs__msg__AccelAuxRpt * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // raw_pedal_pos
  // raw_pedal_pos_is_valid
  // raw_pedal_force
  // raw_pedal_force_is_valid
  // user_interaction
  // user_interaction_is_valid
  // brake_interlock_active
  // brake_interlock_active_is_valid
}

bool
pacmod_msgs__msg__AccelAuxRpt__are_equal(const pacmod_msgs__msg__AccelAuxRpt * lhs, const pacmod_msgs__msg__AccelAuxRpt * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // raw_pedal_pos
  if (lhs->raw_pedal_pos != rhs->raw_pedal_pos) {
    return false;
  }
  // raw_pedal_pos_is_valid
  if (lhs->raw_pedal_pos_is_valid != rhs->raw_pedal_pos_is_valid) {
    return false;
  }
  // raw_pedal_force
  if (lhs->raw_pedal_force != rhs->raw_pedal_force) {
    return false;
  }
  // raw_pedal_force_is_valid
  if (lhs->raw_pedal_force_is_valid != rhs->raw_pedal_force_is_valid) {
    return false;
  }
  // user_interaction
  if (lhs->user_interaction != rhs->user_interaction) {
    return false;
  }
  // user_interaction_is_valid
  if (lhs->user_interaction_is_valid != rhs->user_interaction_is_valid) {
    return false;
  }
  // brake_interlock_active
  if (lhs->brake_interlock_active != rhs->brake_interlock_active) {
    return false;
  }
  // brake_interlock_active_is_valid
  if (lhs->brake_interlock_active_is_valid != rhs->brake_interlock_active_is_valid) {
    return false;
  }
  return true;
}

bool
pacmod_msgs__msg__AccelAuxRpt__copy(
  const pacmod_msgs__msg__AccelAuxRpt * input,
  pacmod_msgs__msg__AccelAuxRpt * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // raw_pedal_pos
  output->raw_pedal_pos = input->raw_pedal_pos;
  // raw_pedal_pos_is_valid
  output->raw_pedal_pos_is_valid = input->raw_pedal_pos_is_valid;
  // raw_pedal_force
  output->raw_pedal_force = input->raw_pedal_force;
  // raw_pedal_force_is_valid
  output->raw_pedal_force_is_valid = input->raw_pedal_force_is_valid;
  // user_interaction
  output->user_interaction = input->user_interaction;
  // user_interaction_is_valid
  output->user_interaction_is_valid = input->user_interaction_is_valid;
  // brake_interlock_active
  output->brake_interlock_active = input->brake_interlock_active;
  // brake_interlock_active_is_valid
  output->brake_interlock_active_is_valid = input->brake_interlock_active_is_valid;
  return true;
}

pacmod_msgs__msg__AccelAuxRpt *
pacmod_msgs__msg__AccelAuxRpt__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  pacmod_msgs__msg__AccelAuxRpt * msg = (pacmod_msgs__msg__AccelAuxRpt *)allocator.allocate(sizeof(pacmod_msgs__msg__AccelAuxRpt), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(pacmod_msgs__msg__AccelAuxRpt));
  bool success = pacmod_msgs__msg__AccelAuxRpt__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
pacmod_msgs__msg__AccelAuxRpt__destroy(pacmod_msgs__msg__AccelAuxRpt * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    pacmod_msgs__msg__AccelAuxRpt__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
pacmod_msgs__msg__AccelAuxRpt__Sequence__init(pacmod_msgs__msg__AccelAuxRpt__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  pacmod_msgs__msg__AccelAuxRpt * data = NULL;

  if (size) {
    data = (pacmod_msgs__msg__AccelAuxRpt *)allocator.zero_allocate(size, sizeof(pacmod_msgs__msg__AccelAuxRpt), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = pacmod_msgs__msg__AccelAuxRpt__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        pacmod_msgs__msg__AccelAuxRpt__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
pacmod_msgs__msg__AccelAuxRpt__Sequence__fini(pacmod_msgs__msg__AccelAuxRpt__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      pacmod_msgs__msg__AccelAuxRpt__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

pacmod_msgs__msg__AccelAuxRpt__Sequence *
pacmod_msgs__msg__AccelAuxRpt__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  pacmod_msgs__msg__AccelAuxRpt__Sequence * array = (pacmod_msgs__msg__AccelAuxRpt__Sequence *)allocator.allocate(sizeof(pacmod_msgs__msg__AccelAuxRpt__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = pacmod_msgs__msg__AccelAuxRpt__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
pacmod_msgs__msg__AccelAuxRpt__Sequence__destroy(pacmod_msgs__msg__AccelAuxRpt__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    pacmod_msgs__msg__AccelAuxRpt__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
pacmod_msgs__msg__AccelAuxRpt__Sequence__are_equal(const pacmod_msgs__msg__AccelAuxRpt__Sequence * lhs, const pacmod_msgs__msg__AccelAuxRpt__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!pacmod_msgs__msg__AccelAuxRpt__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
pacmod_msgs__msg__AccelAuxRpt__Sequence__copy(
  const pacmod_msgs__msg__AccelAuxRpt__Sequence * input,
  pacmod_msgs__msg__AccelAuxRpt__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(pacmod_msgs__msg__AccelAuxRpt);
    pacmod_msgs__msg__AccelAuxRpt * data =
      (pacmod_msgs__msg__AccelAuxRpt *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!pacmod_msgs__msg__AccelAuxRpt__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          pacmod_msgs__msg__AccelAuxRpt__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!pacmod_msgs__msg__AccelAuxRpt__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
