// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from pacmod_msgs:msg/AccelAuxRpt.idl
// generated code does not contain a copyright notice

#ifndef PACMOD_MSGS__MSG__DETAIL__ACCEL_AUX_RPT__FUNCTIONS_H_
#define PACMOD_MSGS__MSG__DETAIL__ACCEL_AUX_RPT__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "pacmod_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "pacmod_msgs/msg/detail/accel_aux_rpt__struct.h"

/// Initialize msg/AccelAuxRpt message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * pacmod_msgs__msg__AccelAuxRpt
 * )) before or use
 * pacmod_msgs__msg__AccelAuxRpt__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_pacmod_msgs
bool
pacmod_msgs__msg__AccelAuxRpt__init(pacmod_msgs__msg__AccelAuxRpt * msg);

/// Finalize msg/AccelAuxRpt message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_pacmod_msgs
void
pacmod_msgs__msg__AccelAuxRpt__fini(pacmod_msgs__msg__AccelAuxRpt * msg);

/// Create msg/AccelAuxRpt message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * pacmod_msgs__msg__AccelAuxRpt__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_pacmod_msgs
pacmod_msgs__msg__AccelAuxRpt *
pacmod_msgs__msg__AccelAuxRpt__create();

/// Destroy msg/AccelAuxRpt message.
/**
 * It calls
 * pacmod_msgs__msg__AccelAuxRpt__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_pacmod_msgs
void
pacmod_msgs__msg__AccelAuxRpt__destroy(pacmod_msgs__msg__AccelAuxRpt * msg);

/// Check for msg/AccelAuxRpt message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_pacmod_msgs
bool
pacmod_msgs__msg__AccelAuxRpt__are_equal(const pacmod_msgs__msg__AccelAuxRpt * lhs, const pacmod_msgs__msg__AccelAuxRpt * rhs);

/// Copy a msg/AccelAuxRpt message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_pacmod_msgs
bool
pacmod_msgs__msg__AccelAuxRpt__copy(
  const pacmod_msgs__msg__AccelAuxRpt * input,
  pacmod_msgs__msg__AccelAuxRpt * output);

/// Initialize array of msg/AccelAuxRpt messages.
/**
 * It allocates the memory for the number of elements and calls
 * pacmod_msgs__msg__AccelAuxRpt__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_pacmod_msgs
bool
pacmod_msgs__msg__AccelAuxRpt__Sequence__init(pacmod_msgs__msg__AccelAuxRpt__Sequence * array, size_t size);

/// Finalize array of msg/AccelAuxRpt messages.
/**
 * It calls
 * pacmod_msgs__msg__AccelAuxRpt__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_pacmod_msgs
void
pacmod_msgs__msg__AccelAuxRpt__Sequence__fini(pacmod_msgs__msg__AccelAuxRpt__Sequence * array);

/// Create array of msg/AccelAuxRpt messages.
/**
 * It allocates the memory for the array and calls
 * pacmod_msgs__msg__AccelAuxRpt__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_pacmod_msgs
pacmod_msgs__msg__AccelAuxRpt__Sequence *
pacmod_msgs__msg__AccelAuxRpt__Sequence__create(size_t size);

/// Destroy array of msg/AccelAuxRpt messages.
/**
 * It calls
 * pacmod_msgs__msg__AccelAuxRpt__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_pacmod_msgs
void
pacmod_msgs__msg__AccelAuxRpt__Sequence__destroy(pacmod_msgs__msg__AccelAuxRpt__Sequence * array);

/// Check for msg/AccelAuxRpt message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_pacmod_msgs
bool
pacmod_msgs__msg__AccelAuxRpt__Sequence__are_equal(const pacmod_msgs__msg__AccelAuxRpt__Sequence * lhs, const pacmod_msgs__msg__AccelAuxRpt__Sequence * rhs);

/// Copy an array of msg/AccelAuxRpt messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_pacmod_msgs
bool
pacmod_msgs__msg__AccelAuxRpt__Sequence__copy(
  const pacmod_msgs__msg__AccelAuxRpt__Sequence * input,
  pacmod_msgs__msg__AccelAuxRpt__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // PACMOD_MSGS__MSG__DETAIL__ACCEL_AUX_RPT__FUNCTIONS_H_
