// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from pacmod_msgs:msg/AllSystemStatuses.idl
// generated code does not contain a copyright notice
#include "pacmod_msgs/msg/detail/all_system_statuses__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `enabled_status`
// Member `overridden_status`
// Member `fault_status`
#include "pacmod_msgs/msg/detail/key_value_pair__functions.h"

bool
pacmod_msgs__msg__AllSystemStatuses__init(pacmod_msgs__msg__AllSystemStatuses * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    pacmod_msgs__msg__AllSystemStatuses__fini(msg);
    return false;
  }
  // enabled_status
  if (!pacmod_msgs__msg__KeyValuePair__Sequence__init(&msg->enabled_status, 0)) {
    pacmod_msgs__msg__AllSystemStatuses__fini(msg);
    return false;
  }
  // overridden_status
  if (!pacmod_msgs__msg__KeyValuePair__Sequence__init(&msg->overridden_status, 0)) {
    pacmod_msgs__msg__AllSystemStatuses__fini(msg);
    return false;
  }
  // fault_status
  if (!pacmod_msgs__msg__KeyValuePair__Sequence__init(&msg->fault_status, 0)) {
    pacmod_msgs__msg__AllSystemStatuses__fini(msg);
    return false;
  }
  return true;
}

void
pacmod_msgs__msg__AllSystemStatuses__fini(pacmod_msgs__msg__AllSystemStatuses * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // enabled_status
  pacmod_msgs__msg__KeyValuePair__Sequence__fini(&msg->enabled_status);
  // overridden_status
  pacmod_msgs__msg__KeyValuePair__Sequence__fini(&msg->overridden_status);
  // fault_status
  pacmod_msgs__msg__KeyValuePair__Sequence__fini(&msg->fault_status);
}

bool
pacmod_msgs__msg__AllSystemStatuses__are_equal(const pacmod_msgs__msg__AllSystemStatuses * lhs, const pacmod_msgs__msg__AllSystemStatuses * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // enabled_status
  if (!pacmod_msgs__msg__KeyValuePair__Sequence__are_equal(
      &(lhs->enabled_status), &(rhs->enabled_status)))
  {
    return false;
  }
  // overridden_status
  if (!pacmod_msgs__msg__KeyValuePair__Sequence__are_equal(
      &(lhs->overridden_status), &(rhs->overridden_status)))
  {
    return false;
  }
  // fault_status
  if (!pacmod_msgs__msg__KeyValuePair__Sequence__are_equal(
      &(lhs->fault_status), &(rhs->fault_status)))
  {
    return false;
  }
  return true;
}

bool
pacmod_msgs__msg__AllSystemStatuses__copy(
  const pacmod_msgs__msg__AllSystemStatuses * input,
  pacmod_msgs__msg__AllSystemStatuses * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // enabled_status
  if (!pacmod_msgs__msg__KeyValuePair__Sequence__copy(
      &(input->enabled_status), &(output->enabled_status)))
  {
    return false;
  }
  // overridden_status
  if (!pacmod_msgs__msg__KeyValuePair__Sequence__copy(
      &(input->overridden_status), &(output->overridden_status)))
  {
    return false;
  }
  // fault_status
  if (!pacmod_msgs__msg__KeyValuePair__Sequence__copy(
      &(input->fault_status), &(output->fault_status)))
  {
    return false;
  }
  return true;
}

pacmod_msgs__msg__AllSystemStatuses *
pacmod_msgs__msg__AllSystemStatuses__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  pacmod_msgs__msg__AllSystemStatuses * msg = (pacmod_msgs__msg__AllSystemStatuses *)allocator.allocate(sizeof(pacmod_msgs__msg__AllSystemStatuses), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(pacmod_msgs__msg__AllSystemStatuses));
  bool success = pacmod_msgs__msg__AllSystemStatuses__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
pacmod_msgs__msg__AllSystemStatuses__destroy(pacmod_msgs__msg__AllSystemStatuses * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    pacmod_msgs__msg__AllSystemStatuses__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
pacmod_msgs__msg__AllSystemStatuses__Sequence__init(pacmod_msgs__msg__AllSystemStatuses__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  pacmod_msgs__msg__AllSystemStatuses * data = NULL;

  if (size) {
    data = (pacmod_msgs__msg__AllSystemStatuses *)allocator.zero_allocate(size, sizeof(pacmod_msgs__msg__AllSystemStatuses), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = pacmod_msgs__msg__AllSystemStatuses__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        pacmod_msgs__msg__AllSystemStatuses__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
pacmod_msgs__msg__AllSystemStatuses__Sequence__fini(pacmod_msgs__msg__AllSystemStatuses__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      pacmod_msgs__msg__AllSystemStatuses__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

pacmod_msgs__msg__AllSystemStatuses__Sequence *
pacmod_msgs__msg__AllSystemStatuses__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  pacmod_msgs__msg__AllSystemStatuses__Sequence * array = (pacmod_msgs__msg__AllSystemStatuses__Sequence *)allocator.allocate(sizeof(pacmod_msgs__msg__AllSystemStatuses__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = pacmod_msgs__msg__AllSystemStatuses__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
pacmod_msgs__msg__AllSystemStatuses__Sequence__destroy(pacmod_msgs__msg__AllSystemStatuses__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    pacmod_msgs__msg__AllSystemStatuses__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
pacmod_msgs__msg__AllSystemStatuses__Sequence__are_equal(const pacmod_msgs__msg__AllSystemStatuses__Sequence * lhs, const pacmod_msgs__msg__AllSystemStatuses__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!pacmod_msgs__msg__AllSystemStatuses__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
pacmod_msgs__msg__AllSystemStatuses__Sequence__copy(
  const pacmod_msgs__msg__AllSystemStatuses__Sequence * input,
  pacmod_msgs__msg__AllSystemStatuses__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(pacmod_msgs__msg__AllSystemStatuses);
    pacmod_msgs__msg__AllSystemStatuses * data =
      (pacmod_msgs__msg__AllSystemStatuses *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!pacmod_msgs__msg__AllSystemStatuses__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          pacmod_msgs__msg__AllSystemStatuses__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!pacmod_msgs__msg__AllSystemStatuses__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
