// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from pacmod_msgs:msg/ComponentRpt.idl
// generated code does not contain a copyright notice
#include "pacmod_msgs/msg/detail/component_rpt__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
pacmod_msgs__msg__ComponentRpt__init(pacmod_msgs__msg__ComponentRpt * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    pacmod_msgs__msg__ComponentRpt__fini(msg);
    return false;
  }
  // component_type
  // component_func
  // counter
  // complement
  // config_fault
  return true;
}

void
pacmod_msgs__msg__ComponentRpt__fini(pacmod_msgs__msg__ComponentRpt * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // component_type
  // component_func
  // counter
  // complement
  // config_fault
}

bool
pacmod_msgs__msg__ComponentRpt__are_equal(const pacmod_msgs__msg__ComponentRpt * lhs, const pacmod_msgs__msg__ComponentRpt * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // component_type
  if (lhs->component_type != rhs->component_type) {
    return false;
  }
  // component_func
  if (lhs->component_func != rhs->component_func) {
    return false;
  }
  // counter
  if (lhs->counter != rhs->counter) {
    return false;
  }
  // complement
  if (lhs->complement != rhs->complement) {
    return false;
  }
  // config_fault
  if (lhs->config_fault != rhs->config_fault) {
    return false;
  }
  return true;
}

bool
pacmod_msgs__msg__ComponentRpt__copy(
  const pacmod_msgs__msg__ComponentRpt * input,
  pacmod_msgs__msg__ComponentRpt * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // component_type
  output->component_type = input->component_type;
  // component_func
  output->component_func = input->component_func;
  // counter
  output->counter = input->counter;
  // complement
  output->complement = input->complement;
  // config_fault
  output->config_fault = input->config_fault;
  return true;
}

pacmod_msgs__msg__ComponentRpt *
pacmod_msgs__msg__ComponentRpt__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  pacmod_msgs__msg__ComponentRpt * msg = (pacmod_msgs__msg__ComponentRpt *)allocator.allocate(sizeof(pacmod_msgs__msg__ComponentRpt), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(pacmod_msgs__msg__ComponentRpt));
  bool success = pacmod_msgs__msg__ComponentRpt__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
pacmod_msgs__msg__ComponentRpt__destroy(pacmod_msgs__msg__ComponentRpt * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    pacmod_msgs__msg__ComponentRpt__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
pacmod_msgs__msg__ComponentRpt__Sequence__init(pacmod_msgs__msg__ComponentRpt__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  pacmod_msgs__msg__ComponentRpt * data = NULL;

  if (size) {
    data = (pacmod_msgs__msg__ComponentRpt *)allocator.zero_allocate(size, sizeof(pacmod_msgs__msg__ComponentRpt), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = pacmod_msgs__msg__ComponentRpt__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        pacmod_msgs__msg__ComponentRpt__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
pacmod_msgs__msg__ComponentRpt__Sequence__fini(pacmod_msgs__msg__ComponentRpt__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      pacmod_msgs__msg__ComponentRpt__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

pacmod_msgs__msg__ComponentRpt__Sequence *
pacmod_msgs__msg__ComponentRpt__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  pacmod_msgs__msg__ComponentRpt__Sequence * array = (pacmod_msgs__msg__ComponentRpt__Sequence *)allocator.allocate(sizeof(pacmod_msgs__msg__ComponentRpt__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = pacmod_msgs__msg__ComponentRpt__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
pacmod_msgs__msg__ComponentRpt__Sequence__destroy(pacmod_msgs__msg__ComponentRpt__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    pacmod_msgs__msg__ComponentRpt__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
pacmod_msgs__msg__ComponentRpt__Sequence__are_equal(const pacmod_msgs__msg__ComponentRpt__Sequence * lhs, const pacmod_msgs__msg__ComponentRpt__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!pacmod_msgs__msg__ComponentRpt__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
pacmod_msgs__msg__ComponentRpt__Sequence__copy(
  const pacmod_msgs__msg__ComponentRpt__Sequence * input,
  pacmod_msgs__msg__ComponentRpt__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(pacmod_msgs__msg__ComponentRpt);
    pacmod_msgs__msg__ComponentRpt * data =
      (pacmod_msgs__msg__ComponentRpt *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!pacmod_msgs__msg__ComponentRpt__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          pacmod_msgs__msg__ComponentRpt__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!pacmod_msgs__msg__ComponentRpt__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
