// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from pacmod_msgs:msg/DoorRpt.idl
// generated code does not contain a copyright notice
#include "pacmod_msgs/msg/detail/door_rpt__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
pacmod_msgs__msg__DoorRpt__init(pacmod_msgs__msg__DoorRpt * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    pacmod_msgs__msg__DoorRpt__fini(msg);
    return false;
  }
  // driver_door_open
  // driver_door_open_is_valid
  // passenger_door_open
  // passenger_door_open_is_valid
  // rear_driver_door_open
  // rear_driver_door_open_is_valid
  // rear_passenger_door_open
  // rear_passenger_door_open_is_valid
  // hood_open
  // hood_open_is_valid
  // trunk_open
  // trunk_open_is_valid
  // fuel_door_open
  // fuel_door_open_is_valid
  return true;
}

void
pacmod_msgs__msg__DoorRpt__fini(pacmod_msgs__msg__DoorRpt * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // driver_door_open
  // driver_door_open_is_valid
  // passenger_door_open
  // passenger_door_open_is_valid
  // rear_driver_door_open
  // rear_driver_door_open_is_valid
  // rear_passenger_door_open
  // rear_passenger_door_open_is_valid
  // hood_open
  // hood_open_is_valid
  // trunk_open
  // trunk_open_is_valid
  // fuel_door_open
  // fuel_door_open_is_valid
}

bool
pacmod_msgs__msg__DoorRpt__are_equal(const pacmod_msgs__msg__DoorRpt * lhs, const pacmod_msgs__msg__DoorRpt * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // driver_door_open
  if (lhs->driver_door_open != rhs->driver_door_open) {
    return false;
  }
  // driver_door_open_is_valid
  if (lhs->driver_door_open_is_valid != rhs->driver_door_open_is_valid) {
    return false;
  }
  // passenger_door_open
  if (lhs->passenger_door_open != rhs->passenger_door_open) {
    return false;
  }
  // passenger_door_open_is_valid
  if (lhs->passenger_door_open_is_valid != rhs->passenger_door_open_is_valid) {
    return false;
  }
  // rear_driver_door_open
  if (lhs->rear_driver_door_open != rhs->rear_driver_door_open) {
    return false;
  }
  // rear_driver_door_open_is_valid
  if (lhs->rear_driver_door_open_is_valid != rhs->rear_driver_door_open_is_valid) {
    return false;
  }
  // rear_passenger_door_open
  if (lhs->rear_passenger_door_open != rhs->rear_passenger_door_open) {
    return false;
  }
  // rear_passenger_door_open_is_valid
  if (lhs->rear_passenger_door_open_is_valid != rhs->rear_passenger_door_open_is_valid) {
    return false;
  }
  // hood_open
  if (lhs->hood_open != rhs->hood_open) {
    return false;
  }
  // hood_open_is_valid
  if (lhs->hood_open_is_valid != rhs->hood_open_is_valid) {
    return false;
  }
  // trunk_open
  if (lhs->trunk_open != rhs->trunk_open) {
    return false;
  }
  // trunk_open_is_valid
  if (lhs->trunk_open_is_valid != rhs->trunk_open_is_valid) {
    return false;
  }
  // fuel_door_open
  if (lhs->fuel_door_open != rhs->fuel_door_open) {
    return false;
  }
  // fuel_door_open_is_valid
  if (lhs->fuel_door_open_is_valid != rhs->fuel_door_open_is_valid) {
    return false;
  }
  return true;
}

bool
pacmod_msgs__msg__DoorRpt__copy(
  const pacmod_msgs__msg__DoorRpt * input,
  pacmod_msgs__msg__DoorRpt * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // driver_door_open
  output->driver_door_open = input->driver_door_open;
  // driver_door_open_is_valid
  output->driver_door_open_is_valid = input->driver_door_open_is_valid;
  // passenger_door_open
  output->passenger_door_open = input->passenger_door_open;
  // passenger_door_open_is_valid
  output->passenger_door_open_is_valid = input->passenger_door_open_is_valid;
  // rear_driver_door_open
  output->rear_driver_door_open = input->rear_driver_door_open;
  // rear_driver_door_open_is_valid
  output->rear_driver_door_open_is_valid = input->rear_driver_door_open_is_valid;
  // rear_passenger_door_open
  output->rear_passenger_door_open = input->rear_passenger_door_open;
  // rear_passenger_door_open_is_valid
  output->rear_passenger_door_open_is_valid = input->rear_passenger_door_open_is_valid;
  // hood_open
  output->hood_open = input->hood_open;
  // hood_open_is_valid
  output->hood_open_is_valid = input->hood_open_is_valid;
  // trunk_open
  output->trunk_open = input->trunk_open;
  // trunk_open_is_valid
  output->trunk_open_is_valid = input->trunk_open_is_valid;
  // fuel_door_open
  output->fuel_door_open = input->fuel_door_open;
  // fuel_door_open_is_valid
  output->fuel_door_open_is_valid = input->fuel_door_open_is_valid;
  return true;
}

pacmod_msgs__msg__DoorRpt *
pacmod_msgs__msg__DoorRpt__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  pacmod_msgs__msg__DoorRpt * msg = (pacmod_msgs__msg__DoorRpt *)allocator.allocate(sizeof(pacmod_msgs__msg__DoorRpt), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(pacmod_msgs__msg__DoorRpt));
  bool success = pacmod_msgs__msg__DoorRpt__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
pacmod_msgs__msg__DoorRpt__destroy(pacmod_msgs__msg__DoorRpt * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    pacmod_msgs__msg__DoorRpt__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
pacmod_msgs__msg__DoorRpt__Sequence__init(pacmod_msgs__msg__DoorRpt__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  pacmod_msgs__msg__DoorRpt * data = NULL;

  if (size) {
    data = (pacmod_msgs__msg__DoorRpt *)allocator.zero_allocate(size, sizeof(pacmod_msgs__msg__DoorRpt), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = pacmod_msgs__msg__DoorRpt__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        pacmod_msgs__msg__DoorRpt__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
pacmod_msgs__msg__DoorRpt__Sequence__fini(pacmod_msgs__msg__DoorRpt__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      pacmod_msgs__msg__DoorRpt__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

pacmod_msgs__msg__DoorRpt__Sequence *
pacmod_msgs__msg__DoorRpt__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  pacmod_msgs__msg__DoorRpt__Sequence * array = (pacmod_msgs__msg__DoorRpt__Sequence *)allocator.allocate(sizeof(pacmod_msgs__msg__DoorRpt__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = pacmod_msgs__msg__DoorRpt__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
pacmod_msgs__msg__DoorRpt__Sequence__destroy(pacmod_msgs__msg__DoorRpt__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    pacmod_msgs__msg__DoorRpt__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
pacmod_msgs__msg__DoorRpt__Sequence__are_equal(const pacmod_msgs__msg__DoorRpt__Sequence * lhs, const pacmod_msgs__msg__DoorRpt__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!pacmod_msgs__msg__DoorRpt__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
pacmod_msgs__msg__DoorRpt__Sequence__copy(
  const pacmod_msgs__msg__DoorRpt__Sequence * input,
  pacmod_msgs__msg__DoorRpt__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(pacmod_msgs__msg__DoorRpt);
    pacmod_msgs__msg__DoorRpt * data =
      (pacmod_msgs__msg__DoorRpt *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!pacmod_msgs__msg__DoorRpt__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          pacmod_msgs__msg__DoorRpt__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!pacmod_msgs__msg__DoorRpt__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
