// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from pacmod_msgs:msg/EngineRpt.idl
// generated code does not contain a copyright notice
#include "pacmod_msgs/msg/detail/engine_rpt__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
pacmod_msgs__msg__EngineRpt__init(pacmod_msgs__msg__EngineRpt * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    pacmod_msgs__msg__EngineRpt__fini(msg);
    return false;
  }
  // engine_speed
  // engine_torque
  // engine_coolant_temp
  // engine_speed_avail
  // engine_torque_avail
  // engine_coolant_temp_avail
  return true;
}

void
pacmod_msgs__msg__EngineRpt__fini(pacmod_msgs__msg__EngineRpt * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // engine_speed
  // engine_torque
  // engine_coolant_temp
  // engine_speed_avail
  // engine_torque_avail
  // engine_coolant_temp_avail
}

bool
pacmod_msgs__msg__EngineRpt__are_equal(const pacmod_msgs__msg__EngineRpt * lhs, const pacmod_msgs__msg__EngineRpt * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // engine_speed
  if (lhs->engine_speed != rhs->engine_speed) {
    return false;
  }
  // engine_torque
  if (lhs->engine_torque != rhs->engine_torque) {
    return false;
  }
  // engine_coolant_temp
  if (lhs->engine_coolant_temp != rhs->engine_coolant_temp) {
    return false;
  }
  // engine_speed_avail
  if (lhs->engine_speed_avail != rhs->engine_speed_avail) {
    return false;
  }
  // engine_torque_avail
  if (lhs->engine_torque_avail != rhs->engine_torque_avail) {
    return false;
  }
  // engine_coolant_temp_avail
  if (lhs->engine_coolant_temp_avail != rhs->engine_coolant_temp_avail) {
    return false;
  }
  return true;
}

bool
pacmod_msgs__msg__EngineRpt__copy(
  const pacmod_msgs__msg__EngineRpt * input,
  pacmod_msgs__msg__EngineRpt * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // engine_speed
  output->engine_speed = input->engine_speed;
  // engine_torque
  output->engine_torque = input->engine_torque;
  // engine_coolant_temp
  output->engine_coolant_temp = input->engine_coolant_temp;
  // engine_speed_avail
  output->engine_speed_avail = input->engine_speed_avail;
  // engine_torque_avail
  output->engine_torque_avail = input->engine_torque_avail;
  // engine_coolant_temp_avail
  output->engine_coolant_temp_avail = input->engine_coolant_temp_avail;
  return true;
}

pacmod_msgs__msg__EngineRpt *
pacmod_msgs__msg__EngineRpt__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  pacmod_msgs__msg__EngineRpt * msg = (pacmod_msgs__msg__EngineRpt *)allocator.allocate(sizeof(pacmod_msgs__msg__EngineRpt), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(pacmod_msgs__msg__EngineRpt));
  bool success = pacmod_msgs__msg__EngineRpt__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
pacmod_msgs__msg__EngineRpt__destroy(pacmod_msgs__msg__EngineRpt * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    pacmod_msgs__msg__EngineRpt__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
pacmod_msgs__msg__EngineRpt__Sequence__init(pacmod_msgs__msg__EngineRpt__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  pacmod_msgs__msg__EngineRpt * data = NULL;

  if (size) {
    data = (pacmod_msgs__msg__EngineRpt *)allocator.zero_allocate(size, sizeof(pacmod_msgs__msg__EngineRpt), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = pacmod_msgs__msg__EngineRpt__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        pacmod_msgs__msg__EngineRpt__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
pacmod_msgs__msg__EngineRpt__Sequence__fini(pacmod_msgs__msg__EngineRpt__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      pacmod_msgs__msg__EngineRpt__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

pacmod_msgs__msg__EngineRpt__Sequence *
pacmod_msgs__msg__EngineRpt__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  pacmod_msgs__msg__EngineRpt__Sequence * array = (pacmod_msgs__msg__EngineRpt__Sequence *)allocator.allocate(sizeof(pacmod_msgs__msg__EngineRpt__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = pacmod_msgs__msg__EngineRpt__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
pacmod_msgs__msg__EngineRpt__Sequence__destroy(pacmod_msgs__msg__EngineRpt__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    pacmod_msgs__msg__EngineRpt__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
pacmod_msgs__msg__EngineRpt__Sequence__are_equal(const pacmod_msgs__msg__EngineRpt__Sequence * lhs, const pacmod_msgs__msg__EngineRpt__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!pacmod_msgs__msg__EngineRpt__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
pacmod_msgs__msg__EngineRpt__Sequence__copy(
  const pacmod_msgs__msg__EngineRpt__Sequence * input,
  pacmod_msgs__msg__EngineRpt__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(pacmod_msgs__msg__EngineRpt);
    pacmod_msgs__msg__EngineRpt * data =
      (pacmod_msgs__msg__EngineRpt *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!pacmod_msgs__msg__EngineRpt__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          pacmod_msgs__msg__EngineRpt__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!pacmod_msgs__msg__EngineRpt__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
