// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from pacmod_msgs:msg/InteriorLightsRpt.idl
// generated code does not contain a copyright notice
#include "pacmod_msgs/msg/detail/interior_lights_rpt__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
pacmod_msgs__msg__InteriorLightsRpt__init(pacmod_msgs__msg__InteriorLightsRpt * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    pacmod_msgs__msg__InteriorLightsRpt__fini(msg);
    return false;
  }
  // front_dome_lights_on
  // front_dome_lights_on_is_valid
  // rear_dome_lights_on
  // rear_dome_lights_on_is_valid
  // mood_lights_on
  // mood_lights_on_is_valid
  // dim_level
  // dim_level_is_valid
  return true;
}

void
pacmod_msgs__msg__InteriorLightsRpt__fini(pacmod_msgs__msg__InteriorLightsRpt * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // front_dome_lights_on
  // front_dome_lights_on_is_valid
  // rear_dome_lights_on
  // rear_dome_lights_on_is_valid
  // mood_lights_on
  // mood_lights_on_is_valid
  // dim_level
  // dim_level_is_valid
}

bool
pacmod_msgs__msg__InteriorLightsRpt__are_equal(const pacmod_msgs__msg__InteriorLightsRpt * lhs, const pacmod_msgs__msg__InteriorLightsRpt * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // front_dome_lights_on
  if (lhs->front_dome_lights_on != rhs->front_dome_lights_on) {
    return false;
  }
  // front_dome_lights_on_is_valid
  if (lhs->front_dome_lights_on_is_valid != rhs->front_dome_lights_on_is_valid) {
    return false;
  }
  // rear_dome_lights_on
  if (lhs->rear_dome_lights_on != rhs->rear_dome_lights_on) {
    return false;
  }
  // rear_dome_lights_on_is_valid
  if (lhs->rear_dome_lights_on_is_valid != rhs->rear_dome_lights_on_is_valid) {
    return false;
  }
  // mood_lights_on
  if (lhs->mood_lights_on != rhs->mood_lights_on) {
    return false;
  }
  // mood_lights_on_is_valid
  if (lhs->mood_lights_on_is_valid != rhs->mood_lights_on_is_valid) {
    return false;
  }
  // dim_level
  if (lhs->dim_level != rhs->dim_level) {
    return false;
  }
  // dim_level_is_valid
  if (lhs->dim_level_is_valid != rhs->dim_level_is_valid) {
    return false;
  }
  return true;
}

bool
pacmod_msgs__msg__InteriorLightsRpt__copy(
  const pacmod_msgs__msg__InteriorLightsRpt * input,
  pacmod_msgs__msg__InteriorLightsRpt * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // front_dome_lights_on
  output->front_dome_lights_on = input->front_dome_lights_on;
  // front_dome_lights_on_is_valid
  output->front_dome_lights_on_is_valid = input->front_dome_lights_on_is_valid;
  // rear_dome_lights_on
  output->rear_dome_lights_on = input->rear_dome_lights_on;
  // rear_dome_lights_on_is_valid
  output->rear_dome_lights_on_is_valid = input->rear_dome_lights_on_is_valid;
  // mood_lights_on
  output->mood_lights_on = input->mood_lights_on;
  // mood_lights_on_is_valid
  output->mood_lights_on_is_valid = input->mood_lights_on_is_valid;
  // dim_level
  output->dim_level = input->dim_level;
  // dim_level_is_valid
  output->dim_level_is_valid = input->dim_level_is_valid;
  return true;
}

pacmod_msgs__msg__InteriorLightsRpt *
pacmod_msgs__msg__InteriorLightsRpt__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  pacmod_msgs__msg__InteriorLightsRpt * msg = (pacmod_msgs__msg__InteriorLightsRpt *)allocator.allocate(sizeof(pacmod_msgs__msg__InteriorLightsRpt), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(pacmod_msgs__msg__InteriorLightsRpt));
  bool success = pacmod_msgs__msg__InteriorLightsRpt__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
pacmod_msgs__msg__InteriorLightsRpt__destroy(pacmod_msgs__msg__InteriorLightsRpt * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    pacmod_msgs__msg__InteriorLightsRpt__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
pacmod_msgs__msg__InteriorLightsRpt__Sequence__init(pacmod_msgs__msg__InteriorLightsRpt__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  pacmod_msgs__msg__InteriorLightsRpt * data = NULL;

  if (size) {
    data = (pacmod_msgs__msg__InteriorLightsRpt *)allocator.zero_allocate(size, sizeof(pacmod_msgs__msg__InteriorLightsRpt), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = pacmod_msgs__msg__InteriorLightsRpt__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        pacmod_msgs__msg__InteriorLightsRpt__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
pacmod_msgs__msg__InteriorLightsRpt__Sequence__fini(pacmod_msgs__msg__InteriorLightsRpt__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      pacmod_msgs__msg__InteriorLightsRpt__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

pacmod_msgs__msg__InteriorLightsRpt__Sequence *
pacmod_msgs__msg__InteriorLightsRpt__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  pacmod_msgs__msg__InteriorLightsRpt__Sequence * array = (pacmod_msgs__msg__InteriorLightsRpt__Sequence *)allocator.allocate(sizeof(pacmod_msgs__msg__InteriorLightsRpt__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = pacmod_msgs__msg__InteriorLightsRpt__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
pacmod_msgs__msg__InteriorLightsRpt__Sequence__destroy(pacmod_msgs__msg__InteriorLightsRpt__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    pacmod_msgs__msg__InteriorLightsRpt__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
pacmod_msgs__msg__InteriorLightsRpt__Sequence__are_equal(const pacmod_msgs__msg__InteriorLightsRpt__Sequence * lhs, const pacmod_msgs__msg__InteriorLightsRpt__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!pacmod_msgs__msg__InteriorLightsRpt__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
pacmod_msgs__msg__InteriorLightsRpt__Sequence__copy(
  const pacmod_msgs__msg__InteriorLightsRpt__Sequence * input,
  pacmod_msgs__msg__InteriorLightsRpt__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(pacmod_msgs__msg__InteriorLightsRpt);
    pacmod_msgs__msg__InteriorLightsRpt * data =
      (pacmod_msgs__msg__InteriorLightsRpt *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!pacmod_msgs__msg__InteriorLightsRpt__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          pacmod_msgs__msg__InteriorLightsRpt__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!pacmod_msgs__msg__InteriorLightsRpt__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
