// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from pacmod_msgs:msg/WiperAuxRpt.idl
// generated code does not contain a copyright notice
#include "pacmod_msgs/msg/detail/wiper_aux_rpt__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
pacmod_msgs__msg__WiperAuxRpt__init(pacmod_msgs__msg__WiperAuxRpt * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    pacmod_msgs__msg__WiperAuxRpt__fini(msg);
    return false;
  }
  // front_wiping
  // front_wiping_is_valid
  // front_spraying
  // front_spraying_is_valid
  // rear_wiping
  // rear_wiping_is_valid
  // rear_spraying
  // rear_spraying_is_valid
  // spray_near_empty
  // spray_near_empty_is_valid
  // spray_empty
  // spray_empty_is_valid
  return true;
}

void
pacmod_msgs__msg__WiperAuxRpt__fini(pacmod_msgs__msg__WiperAuxRpt * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // front_wiping
  // front_wiping_is_valid
  // front_spraying
  // front_spraying_is_valid
  // rear_wiping
  // rear_wiping_is_valid
  // rear_spraying
  // rear_spraying_is_valid
  // spray_near_empty
  // spray_near_empty_is_valid
  // spray_empty
  // spray_empty_is_valid
}

bool
pacmod_msgs__msg__WiperAuxRpt__are_equal(const pacmod_msgs__msg__WiperAuxRpt * lhs, const pacmod_msgs__msg__WiperAuxRpt * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // front_wiping
  if (lhs->front_wiping != rhs->front_wiping) {
    return false;
  }
  // front_wiping_is_valid
  if (lhs->front_wiping_is_valid != rhs->front_wiping_is_valid) {
    return false;
  }
  // front_spraying
  if (lhs->front_spraying != rhs->front_spraying) {
    return false;
  }
  // front_spraying_is_valid
  if (lhs->front_spraying_is_valid != rhs->front_spraying_is_valid) {
    return false;
  }
  // rear_wiping
  if (lhs->rear_wiping != rhs->rear_wiping) {
    return false;
  }
  // rear_wiping_is_valid
  if (lhs->rear_wiping_is_valid != rhs->rear_wiping_is_valid) {
    return false;
  }
  // rear_spraying
  if (lhs->rear_spraying != rhs->rear_spraying) {
    return false;
  }
  // rear_spraying_is_valid
  if (lhs->rear_spraying_is_valid != rhs->rear_spraying_is_valid) {
    return false;
  }
  // spray_near_empty
  if (lhs->spray_near_empty != rhs->spray_near_empty) {
    return false;
  }
  // spray_near_empty_is_valid
  if (lhs->spray_near_empty_is_valid != rhs->spray_near_empty_is_valid) {
    return false;
  }
  // spray_empty
  if (lhs->spray_empty != rhs->spray_empty) {
    return false;
  }
  // spray_empty_is_valid
  if (lhs->spray_empty_is_valid != rhs->spray_empty_is_valid) {
    return false;
  }
  return true;
}

bool
pacmod_msgs__msg__WiperAuxRpt__copy(
  const pacmod_msgs__msg__WiperAuxRpt * input,
  pacmod_msgs__msg__WiperAuxRpt * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // front_wiping
  output->front_wiping = input->front_wiping;
  // front_wiping_is_valid
  output->front_wiping_is_valid = input->front_wiping_is_valid;
  // front_spraying
  output->front_spraying = input->front_spraying;
  // front_spraying_is_valid
  output->front_spraying_is_valid = input->front_spraying_is_valid;
  // rear_wiping
  output->rear_wiping = input->rear_wiping;
  // rear_wiping_is_valid
  output->rear_wiping_is_valid = input->rear_wiping_is_valid;
  // rear_spraying
  output->rear_spraying = input->rear_spraying;
  // rear_spraying_is_valid
  output->rear_spraying_is_valid = input->rear_spraying_is_valid;
  // spray_near_empty
  output->spray_near_empty = input->spray_near_empty;
  // spray_near_empty_is_valid
  output->spray_near_empty_is_valid = input->spray_near_empty_is_valid;
  // spray_empty
  output->spray_empty = input->spray_empty;
  // spray_empty_is_valid
  output->spray_empty_is_valid = input->spray_empty_is_valid;
  return true;
}

pacmod_msgs__msg__WiperAuxRpt *
pacmod_msgs__msg__WiperAuxRpt__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  pacmod_msgs__msg__WiperAuxRpt * msg = (pacmod_msgs__msg__WiperAuxRpt *)allocator.allocate(sizeof(pacmod_msgs__msg__WiperAuxRpt), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(pacmod_msgs__msg__WiperAuxRpt));
  bool success = pacmod_msgs__msg__WiperAuxRpt__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
pacmod_msgs__msg__WiperAuxRpt__destroy(pacmod_msgs__msg__WiperAuxRpt * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    pacmod_msgs__msg__WiperAuxRpt__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
pacmod_msgs__msg__WiperAuxRpt__Sequence__init(pacmod_msgs__msg__WiperAuxRpt__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  pacmod_msgs__msg__WiperAuxRpt * data = NULL;

  if (size) {
    data = (pacmod_msgs__msg__WiperAuxRpt *)allocator.zero_allocate(size, sizeof(pacmod_msgs__msg__WiperAuxRpt), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = pacmod_msgs__msg__WiperAuxRpt__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        pacmod_msgs__msg__WiperAuxRpt__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
pacmod_msgs__msg__WiperAuxRpt__Sequence__fini(pacmod_msgs__msg__WiperAuxRpt__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      pacmod_msgs__msg__WiperAuxRpt__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

pacmod_msgs__msg__WiperAuxRpt__Sequence *
pacmod_msgs__msg__WiperAuxRpt__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  pacmod_msgs__msg__WiperAuxRpt__Sequence * array = (pacmod_msgs__msg__WiperAuxRpt__Sequence *)allocator.allocate(sizeof(pacmod_msgs__msg__WiperAuxRpt__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = pacmod_msgs__msg__WiperAuxRpt__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
pacmod_msgs__msg__WiperAuxRpt__Sequence__destroy(pacmod_msgs__msg__WiperAuxRpt__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    pacmod_msgs__msg__WiperAuxRpt__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
pacmod_msgs__msg__WiperAuxRpt__Sequence__are_equal(const pacmod_msgs__msg__WiperAuxRpt__Sequence * lhs, const pacmod_msgs__msg__WiperAuxRpt__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!pacmod_msgs__msg__WiperAuxRpt__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
pacmod_msgs__msg__WiperAuxRpt__Sequence__copy(
  const pacmod_msgs__msg__WiperAuxRpt__Sequence * input,
  pacmod_msgs__msg__WiperAuxRpt__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(pacmod_msgs__msg__WiperAuxRpt);
    pacmod_msgs__msg__WiperAuxRpt * data =
      (pacmod_msgs__msg__WiperAuxRpt *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!pacmod_msgs__msg__WiperAuxRpt__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          pacmod_msgs__msg__WiperAuxRpt__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!pacmod_msgs__msg__WiperAuxRpt__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
