// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from pacmod_msgs:msg/MotorRpt2.idl
// generated code does not contain a copyright notice
#include "pacmod_msgs/msg/detail/motor_rpt2__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
pacmod_msgs__msg__MotorRpt2__init(pacmod_msgs__msg__MotorRpt2 * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    pacmod_msgs__msg__MotorRpt2__fini(msg);
    return false;
  }
  // encoder_temp
  // motor_temp
  // angular_velocity
  return true;
}

void
pacmod_msgs__msg__MotorRpt2__fini(pacmod_msgs__msg__MotorRpt2 * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // encoder_temp
  // motor_temp
  // angular_velocity
}

bool
pacmod_msgs__msg__MotorRpt2__are_equal(const pacmod_msgs__msg__MotorRpt2 * lhs, const pacmod_msgs__msg__MotorRpt2 * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // encoder_temp
  if (lhs->encoder_temp != rhs->encoder_temp) {
    return false;
  }
  // motor_temp
  if (lhs->motor_temp != rhs->motor_temp) {
    return false;
  }
  // angular_velocity
  if (lhs->angular_velocity != rhs->angular_velocity) {
    return false;
  }
  return true;
}

bool
pacmod_msgs__msg__MotorRpt2__copy(
  const pacmod_msgs__msg__MotorRpt2 * input,
  pacmod_msgs__msg__MotorRpt2 * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // encoder_temp
  output->encoder_temp = input->encoder_temp;
  // motor_temp
  output->motor_temp = input->motor_temp;
  // angular_velocity
  output->angular_velocity = input->angular_velocity;
  return true;
}

pacmod_msgs__msg__MotorRpt2 *
pacmod_msgs__msg__MotorRpt2__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  pacmod_msgs__msg__MotorRpt2 * msg = (pacmod_msgs__msg__MotorRpt2 *)allocator.allocate(sizeof(pacmod_msgs__msg__MotorRpt2), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(pacmod_msgs__msg__MotorRpt2));
  bool success = pacmod_msgs__msg__MotorRpt2__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
pacmod_msgs__msg__MotorRpt2__destroy(pacmod_msgs__msg__MotorRpt2 * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    pacmod_msgs__msg__MotorRpt2__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
pacmod_msgs__msg__MotorRpt2__Sequence__init(pacmod_msgs__msg__MotorRpt2__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  pacmod_msgs__msg__MotorRpt2 * data = NULL;

  if (size) {
    data = (pacmod_msgs__msg__MotorRpt2 *)allocator.zero_allocate(size, sizeof(pacmod_msgs__msg__MotorRpt2), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = pacmod_msgs__msg__MotorRpt2__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        pacmod_msgs__msg__MotorRpt2__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
pacmod_msgs__msg__MotorRpt2__Sequence__fini(pacmod_msgs__msg__MotorRpt2__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      pacmod_msgs__msg__MotorRpt2__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

pacmod_msgs__msg__MotorRpt2__Sequence *
pacmod_msgs__msg__MotorRpt2__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  pacmod_msgs__msg__MotorRpt2__Sequence * array = (pacmod_msgs__msg__MotorRpt2__Sequence *)allocator.allocate(sizeof(pacmod_msgs__msg__MotorRpt2__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = pacmod_msgs__msg__MotorRpt2__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
pacmod_msgs__msg__MotorRpt2__Sequence__destroy(pacmod_msgs__msg__MotorRpt2__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    pacmod_msgs__msg__MotorRpt2__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
pacmod_msgs__msg__MotorRpt2__Sequence__are_equal(const pacmod_msgs__msg__MotorRpt2__Sequence * lhs, const pacmod_msgs__msg__MotorRpt2__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!pacmod_msgs__msg__MotorRpt2__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
pacmod_msgs__msg__MotorRpt2__Sequence__copy(
  const pacmod_msgs__msg__MotorRpt2__Sequence * input,
  pacmod_msgs__msg__MotorRpt2__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(pacmod_msgs__msg__MotorRpt2);
    pacmod_msgs__msg__MotorRpt2 * data =
      (pacmod_msgs__msg__MotorRpt2 *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!pacmod_msgs__msg__MotorRpt2__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          pacmod_msgs__msg__MotorRpt2__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!pacmod_msgs__msg__MotorRpt2__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
