// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from pacmod_msgs:msg/SteeringPIDRpt3.idl
// generated code does not contain a copyright notice
#include "pacmod_msgs/msg/detail/steering_pid_rpt3__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
pacmod_msgs__msg__SteeringPIDRpt3__init(pacmod_msgs__msg__SteeringPIDRpt3 * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    pacmod_msgs__msg__SteeringPIDRpt3__fini(msg);
    return false;
  }
  // new_torque
  // str_angle_desired
  // str_angle_actual
  // error
  return true;
}

void
pacmod_msgs__msg__SteeringPIDRpt3__fini(pacmod_msgs__msg__SteeringPIDRpt3 * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // new_torque
  // str_angle_desired
  // str_angle_actual
  // error
}

bool
pacmod_msgs__msg__SteeringPIDRpt3__are_equal(const pacmod_msgs__msg__SteeringPIDRpt3 * lhs, const pacmod_msgs__msg__SteeringPIDRpt3 * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // new_torque
  if (lhs->new_torque != rhs->new_torque) {
    return false;
  }
  // str_angle_desired
  if (lhs->str_angle_desired != rhs->str_angle_desired) {
    return false;
  }
  // str_angle_actual
  if (lhs->str_angle_actual != rhs->str_angle_actual) {
    return false;
  }
  // error
  if (lhs->error != rhs->error) {
    return false;
  }
  return true;
}

bool
pacmod_msgs__msg__SteeringPIDRpt3__copy(
  const pacmod_msgs__msg__SteeringPIDRpt3 * input,
  pacmod_msgs__msg__SteeringPIDRpt3 * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // new_torque
  output->new_torque = input->new_torque;
  // str_angle_desired
  output->str_angle_desired = input->str_angle_desired;
  // str_angle_actual
  output->str_angle_actual = input->str_angle_actual;
  // error
  output->error = input->error;
  return true;
}

pacmod_msgs__msg__SteeringPIDRpt3 *
pacmod_msgs__msg__SteeringPIDRpt3__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  pacmod_msgs__msg__SteeringPIDRpt3 * msg = (pacmod_msgs__msg__SteeringPIDRpt3 *)allocator.allocate(sizeof(pacmod_msgs__msg__SteeringPIDRpt3), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(pacmod_msgs__msg__SteeringPIDRpt3));
  bool success = pacmod_msgs__msg__SteeringPIDRpt3__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
pacmod_msgs__msg__SteeringPIDRpt3__destroy(pacmod_msgs__msg__SteeringPIDRpt3 * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    pacmod_msgs__msg__SteeringPIDRpt3__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
pacmod_msgs__msg__SteeringPIDRpt3__Sequence__init(pacmod_msgs__msg__SteeringPIDRpt3__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  pacmod_msgs__msg__SteeringPIDRpt3 * data = NULL;

  if (size) {
    data = (pacmod_msgs__msg__SteeringPIDRpt3 *)allocator.zero_allocate(size, sizeof(pacmod_msgs__msg__SteeringPIDRpt3), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = pacmod_msgs__msg__SteeringPIDRpt3__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        pacmod_msgs__msg__SteeringPIDRpt3__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
pacmod_msgs__msg__SteeringPIDRpt3__Sequence__fini(pacmod_msgs__msg__SteeringPIDRpt3__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      pacmod_msgs__msg__SteeringPIDRpt3__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

pacmod_msgs__msg__SteeringPIDRpt3__Sequence *
pacmod_msgs__msg__SteeringPIDRpt3__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  pacmod_msgs__msg__SteeringPIDRpt3__Sequence * array = (pacmod_msgs__msg__SteeringPIDRpt3__Sequence *)allocator.allocate(sizeof(pacmod_msgs__msg__SteeringPIDRpt3__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = pacmod_msgs__msg__SteeringPIDRpt3__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
pacmod_msgs__msg__SteeringPIDRpt3__Sequence__destroy(pacmod_msgs__msg__SteeringPIDRpt3__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    pacmod_msgs__msg__SteeringPIDRpt3__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
pacmod_msgs__msg__SteeringPIDRpt3__Sequence__are_equal(const pacmod_msgs__msg__SteeringPIDRpt3__Sequence * lhs, const pacmod_msgs__msg__SteeringPIDRpt3__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!pacmod_msgs__msg__SteeringPIDRpt3__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
pacmod_msgs__msg__SteeringPIDRpt3__Sequence__copy(
  const pacmod_msgs__msg__SteeringPIDRpt3__Sequence * input,
  pacmod_msgs__msg__SteeringPIDRpt3__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(pacmod_msgs__msg__SteeringPIDRpt3);
    pacmod_msgs__msg__SteeringPIDRpt3 * data =
      (pacmod_msgs__msg__SteeringPIDRpt3 *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!pacmod_msgs__msg__SteeringPIDRpt3__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          pacmod_msgs__msg__SteeringPIDRpt3__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!pacmod_msgs__msg__SteeringPIDRpt3__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
