// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from pacmod_msgs:msg/SystemRptBool.idl
// generated code does not contain a copyright notice
#include "pacmod_msgs/msg/detail/system_rpt_bool__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
pacmod_msgs__msg__SystemRptBool__init(pacmod_msgs__msg__SystemRptBool * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    pacmod_msgs__msg__SystemRptBool__fini(msg);
    return false;
  }
  // enabled
  // override_active
  // command_output_fault
  // input_output_fault
  // output_reported_fault
  // pacmod_fault
  // vehicle_fault
  // manual_input
  // command
  // output
  return true;
}

void
pacmod_msgs__msg__SystemRptBool__fini(pacmod_msgs__msg__SystemRptBool * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // enabled
  // override_active
  // command_output_fault
  // input_output_fault
  // output_reported_fault
  // pacmod_fault
  // vehicle_fault
  // manual_input
  // command
  // output
}

bool
pacmod_msgs__msg__SystemRptBool__are_equal(const pacmod_msgs__msg__SystemRptBool * lhs, const pacmod_msgs__msg__SystemRptBool * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // enabled
  if (lhs->enabled != rhs->enabled) {
    return false;
  }
  // override_active
  if (lhs->override_active != rhs->override_active) {
    return false;
  }
  // command_output_fault
  if (lhs->command_output_fault != rhs->command_output_fault) {
    return false;
  }
  // input_output_fault
  if (lhs->input_output_fault != rhs->input_output_fault) {
    return false;
  }
  // output_reported_fault
  if (lhs->output_reported_fault != rhs->output_reported_fault) {
    return false;
  }
  // pacmod_fault
  if (lhs->pacmod_fault != rhs->pacmod_fault) {
    return false;
  }
  // vehicle_fault
  if (lhs->vehicle_fault != rhs->vehicle_fault) {
    return false;
  }
  // manual_input
  if (lhs->manual_input != rhs->manual_input) {
    return false;
  }
  // command
  if (lhs->command != rhs->command) {
    return false;
  }
  // output
  if (lhs->output != rhs->output) {
    return false;
  }
  return true;
}

bool
pacmod_msgs__msg__SystemRptBool__copy(
  const pacmod_msgs__msg__SystemRptBool * input,
  pacmod_msgs__msg__SystemRptBool * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // enabled
  output->enabled = input->enabled;
  // override_active
  output->override_active = input->override_active;
  // command_output_fault
  output->command_output_fault = input->command_output_fault;
  // input_output_fault
  output->input_output_fault = input->input_output_fault;
  // output_reported_fault
  output->output_reported_fault = input->output_reported_fault;
  // pacmod_fault
  output->pacmod_fault = input->pacmod_fault;
  // vehicle_fault
  output->vehicle_fault = input->vehicle_fault;
  // manual_input
  output->manual_input = input->manual_input;
  // command
  output->command = input->command;
  // output
  output->output = input->output;
  return true;
}

pacmod_msgs__msg__SystemRptBool *
pacmod_msgs__msg__SystemRptBool__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  pacmod_msgs__msg__SystemRptBool * msg = (pacmod_msgs__msg__SystemRptBool *)allocator.allocate(sizeof(pacmod_msgs__msg__SystemRptBool), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(pacmod_msgs__msg__SystemRptBool));
  bool success = pacmod_msgs__msg__SystemRptBool__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
pacmod_msgs__msg__SystemRptBool__destroy(pacmod_msgs__msg__SystemRptBool * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    pacmod_msgs__msg__SystemRptBool__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
pacmod_msgs__msg__SystemRptBool__Sequence__init(pacmod_msgs__msg__SystemRptBool__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  pacmod_msgs__msg__SystemRptBool * data = NULL;

  if (size) {
    data = (pacmod_msgs__msg__SystemRptBool *)allocator.zero_allocate(size, sizeof(pacmod_msgs__msg__SystemRptBool), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = pacmod_msgs__msg__SystemRptBool__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        pacmod_msgs__msg__SystemRptBool__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
pacmod_msgs__msg__SystemRptBool__Sequence__fini(pacmod_msgs__msg__SystemRptBool__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      pacmod_msgs__msg__SystemRptBool__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

pacmod_msgs__msg__SystemRptBool__Sequence *
pacmod_msgs__msg__SystemRptBool__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  pacmod_msgs__msg__SystemRptBool__Sequence * array = (pacmod_msgs__msg__SystemRptBool__Sequence *)allocator.allocate(sizeof(pacmod_msgs__msg__SystemRptBool__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = pacmod_msgs__msg__SystemRptBool__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
pacmod_msgs__msg__SystemRptBool__Sequence__destroy(pacmod_msgs__msg__SystemRptBool__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    pacmod_msgs__msg__SystemRptBool__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
pacmod_msgs__msg__SystemRptBool__Sequence__are_equal(const pacmod_msgs__msg__SystemRptBool__Sequence * lhs, const pacmod_msgs__msg__SystemRptBool__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!pacmod_msgs__msg__SystemRptBool__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
pacmod_msgs__msg__SystemRptBool__Sequence__copy(
  const pacmod_msgs__msg__SystemRptBool__Sequence * input,
  pacmod_msgs__msg__SystemRptBool__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(pacmod_msgs__msg__SystemRptBool);
    pacmod_msgs__msg__SystemRptBool * data =
      (pacmod_msgs__msg__SystemRptBool *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!pacmod_msgs__msg__SystemRptBool__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          pacmod_msgs__msg__SystemRptBool__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!pacmod_msgs__msg__SystemRptBool__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
