// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from pacmod_msgs:msg/VinRpt.idl
// generated code does not contain a copyright notice
#include "pacmod_msgs/msg/detail/vin_rpt__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `mfg_code`
// Member `mfg`
// Member `model_year_code`
#include "rosidl_runtime_c/string_functions.h"

bool
pacmod_msgs__msg__VinRpt__init(pacmod_msgs__msg__VinRpt * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    pacmod_msgs__msg__VinRpt__fini(msg);
    return false;
  }
  // mfg_code
  if (!rosidl_runtime_c__String__init(&msg->mfg_code)) {
    pacmod_msgs__msg__VinRpt__fini(msg);
    return false;
  }
  // mfg
  if (!rosidl_runtime_c__String__init(&msg->mfg)) {
    pacmod_msgs__msg__VinRpt__fini(msg);
    return false;
  }
  // model_year_code
  if (!rosidl_runtime_c__String__init(&msg->model_year_code)) {
    pacmod_msgs__msg__VinRpt__fini(msg);
    return false;
  }
  // model_year
  // serial
  return true;
}

void
pacmod_msgs__msg__VinRpt__fini(pacmod_msgs__msg__VinRpt * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // mfg_code
  rosidl_runtime_c__String__fini(&msg->mfg_code);
  // mfg
  rosidl_runtime_c__String__fini(&msg->mfg);
  // model_year_code
  rosidl_runtime_c__String__fini(&msg->model_year_code);
  // model_year
  // serial
}

bool
pacmod_msgs__msg__VinRpt__are_equal(const pacmod_msgs__msg__VinRpt * lhs, const pacmod_msgs__msg__VinRpt * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // mfg_code
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->mfg_code), &(rhs->mfg_code)))
  {
    return false;
  }
  // mfg
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->mfg), &(rhs->mfg)))
  {
    return false;
  }
  // model_year_code
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->model_year_code), &(rhs->model_year_code)))
  {
    return false;
  }
  // model_year
  if (lhs->model_year != rhs->model_year) {
    return false;
  }
  // serial
  if (lhs->serial != rhs->serial) {
    return false;
  }
  return true;
}

bool
pacmod_msgs__msg__VinRpt__copy(
  const pacmod_msgs__msg__VinRpt * input,
  pacmod_msgs__msg__VinRpt * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // mfg_code
  if (!rosidl_runtime_c__String__copy(
      &(input->mfg_code), &(output->mfg_code)))
  {
    return false;
  }
  // mfg
  if (!rosidl_runtime_c__String__copy(
      &(input->mfg), &(output->mfg)))
  {
    return false;
  }
  // model_year_code
  if (!rosidl_runtime_c__String__copy(
      &(input->model_year_code), &(output->model_year_code)))
  {
    return false;
  }
  // model_year
  output->model_year = input->model_year;
  // serial
  output->serial = input->serial;
  return true;
}

pacmod_msgs__msg__VinRpt *
pacmod_msgs__msg__VinRpt__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  pacmod_msgs__msg__VinRpt * msg = (pacmod_msgs__msg__VinRpt *)allocator.allocate(sizeof(pacmod_msgs__msg__VinRpt), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(pacmod_msgs__msg__VinRpt));
  bool success = pacmod_msgs__msg__VinRpt__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
pacmod_msgs__msg__VinRpt__destroy(pacmod_msgs__msg__VinRpt * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    pacmod_msgs__msg__VinRpt__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
pacmod_msgs__msg__VinRpt__Sequence__init(pacmod_msgs__msg__VinRpt__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  pacmod_msgs__msg__VinRpt * data = NULL;

  if (size) {
    data = (pacmod_msgs__msg__VinRpt *)allocator.zero_allocate(size, sizeof(pacmod_msgs__msg__VinRpt), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = pacmod_msgs__msg__VinRpt__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        pacmod_msgs__msg__VinRpt__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
pacmod_msgs__msg__VinRpt__Sequence__fini(pacmod_msgs__msg__VinRpt__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      pacmod_msgs__msg__VinRpt__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

pacmod_msgs__msg__VinRpt__Sequence *
pacmod_msgs__msg__VinRpt__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  pacmod_msgs__msg__VinRpt__Sequence * array = (pacmod_msgs__msg__VinRpt__Sequence *)allocator.allocate(sizeof(pacmod_msgs__msg__VinRpt__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = pacmod_msgs__msg__VinRpt__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
pacmod_msgs__msg__VinRpt__Sequence__destroy(pacmod_msgs__msg__VinRpt__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    pacmod_msgs__msg__VinRpt__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
pacmod_msgs__msg__VinRpt__Sequence__are_equal(const pacmod_msgs__msg__VinRpt__Sequence * lhs, const pacmod_msgs__msg__VinRpt__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!pacmod_msgs__msg__VinRpt__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
pacmod_msgs__msg__VinRpt__Sequence__copy(
  const pacmod_msgs__msg__VinRpt__Sequence * input,
  pacmod_msgs__msg__VinRpt__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(pacmod_msgs__msg__VinRpt);
    pacmod_msgs__msg__VinRpt * data =
      (pacmod_msgs__msg__VinRpt *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!pacmod_msgs__msg__VinRpt__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          pacmod_msgs__msg__VinRpt__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!pacmod_msgs__msg__VinRpt__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
